#ifndef _IPROXY_DYN_LANG_H_
#define _IPROXY_DYN_LANG_H_

#define NSIZE(a) (sizeof(a) / sizeof(a[0]))

typedef struct _IProxyDynLang IProxyDynLang;
typedef struct _DynLangParams DynLangParams;
struct _DynLangParams {
    int    argc;
    char** argv;
};

struct _IProxyDynLang
{
    void (*FP_proxy_init)(IProxyDynLang*, char* dynFileName);
    void (*FP_proxy_funcall)(IProxyDynLang*, char* funcName, DynLangParams* dynLangParams);
    void (*FP_proxy_end)(IProxyDynLang*);
#ifdef __cplusplus
    void init(char* dynFileName) {
        this->FP_proxy_init(this, dynFileName);
    };
    void funcall(char* funcName, char* my_args[]) {
        this->FP_proxy_funcall(this, funcName, my_args);
    };
    void end() {
        this->FP_proxy_end(this);
    }
#endif
};
IProxyDynLang* GetProxyDynLang();
void IProxyDynLang_init(IProxyDynLang*, char* dynFileName);
void IProxyDynLang_funcall(IProxyDynLang*, char* funcName, DynLangParams* dynLangParams);
void IProxyDynLang_end(IProxyDynLang*);
#endif
